;---------------------------------------------------------------------
; VIDEO.S
;---------------------------------------------------------------------

VideoTiming:	movem.l	a0-a1,-(sp)
		and.w	#$3,d0
		lsl.w	#2,d0		;*4
		lea	video_tab,a0
		move.l	(a0,d0.w),d0
		beq.s	unknown
		move.l	d0,a0
                lea     $f00000,a1	; TOM
                move.w  (a0)+,$2e(a1)
                move.w  (a0)+,$34(a1)
                move.w  (a0)+,$36(a1)
                move.w  (a0)+,$54(a1)
                move.w  (a0)+,$32(a1)
                move.w  (a0)+,$30(a1)
                move.w  (a0)+,$3c(a1)
                move.w  (a0)+,$38(a1) 
                move.w  (a0)+,$3a(a1) 
                move.w  (a0)+,$3e(a1)   ;Vertical
                move.w  (a0)+,$42(a1)
                move.w  (a0)+,$46(a1)
                move.w  (a0)+,$48(a1)
                move.w  (a0)+,$40(a1)
                move.w  (a0)+,$4a(a1) 
                move.w  (a0)+,$44(a1) 
                move.w  (a0)+,$4c(a1) 
                move.w  (a0)+,$4e(a1)

unknown:	movem.l	(sp)+,a0-a1
		rts
				

video_tab:	dc.l	tv50, tv60, 0, vga60


;##################################################################################
tv50:
		dc.w	850		; HP: 1 Halbzeile = 851 Takte
		dc.w  	$0400+725	; HS: HSync, 2.Halbzeile Pos 725
                dc.w  	724		; HVS: End VSync, 724
                dc.w	787		; HEQ: - End, 787
                dc.w	158		; HBE: Blank Ende 
                dc.w  	$0400+687	; HBB: Blank Begin, 2.Halbzeile
                dc.w  	$0400+629	; 509	; HDE: Display-End, 2.Halbzeile
                dc.w  	220 ; 398		; HDB1: Display-Start1
                dc.w  	220 ; 398		; HDB2: Display-Start2

;-------------- Vertical TV50----------------------------------------------------------
                dc.w  	623		;Vertical-Period
                dc.w  	34		;Vertical Blanking End
                dc.w  	92		;Vertical Display Begin
                dc.w  	572		;Vertical Display End
                dc.w  	600		;Vertical Blanking Begin
                dc.w  	613		;Vertical Equalization Begin
                dc.w  	618		;Vertical Sync
                dc.w  	6		;Vertical Equalization End
                dc.w  	573		;Vertical Interrupt, nur ungerade Werte !

;##################################################################################
tv60:           dc.w  	844		; HP
                dc.w  	$06cd		; HS
                dc.w  	$028b		; HVS
                dc.w  	$030e		; HEQ
                dc.w  	$7d		; HBE
                dc.w  	$06b1		; HBB
                dc.w  	$400+467	; HDE: Display-End
                dc.w  	350		; HDB1: Display-Start
                dc.w  	350		; HDB2: Display-Start

                dc.w  	523
                dc.w  	24
                dc.w  	46		;Display-Beginn
                dc.w  	486		;Display-End
                dc.w  	$01f4
                dc.w  	$01ff
                dc.w  	$0205
                dc.w  	6
                dc.w 	505


;##################################################################################
; VGA

;Horizontal Pixelclock = 26,6 Mhz 844 Takte
;1 Zeile = 844 Takte
;Sync:          98
;Porch:         22
;left:          42
;Display:       640
;right:         42
;Front:         0

vga60:          dc.w	844/2-1		;1 Halbzeile, 844 Takte
                dc.w  	$0400+324	;HSync, 2.Halbzeile Pos 324
                dc.w  	323		;HVS End VSync, 601
                dc.w	1		;HEQ - End, 787
                dc.w	22		;Blank Ende (22)
                dc.w  	$0400+324	;Blank Begin, 2.Halbzeile
                dc.w  	$0400+282	;Display-End, 2.Halbzeile (282)
                dc.w  	64		;Display-Start1 (64)
                dc.w  	64		;Display-Start2

;-------------- Vertical ----------------------------------------------------------
                dc.w  	1049		;Vertical-Period, 1050 Halb-Zeilen, kein Interleave
                dc.w  	2*32		;Vertical Blanking End
                dc.w  	2*32		;Vertical Display Begin
                dc.w  	2*513		;Vertical Display End
                dc.w  	2*513		;Vertical Blanking Begin
                dc.w  	-1		;Vertical Equalization Begin
                dc.w  	1046		;Vertical Sync
                dc.w  	6		;Vertical Equalization End
                dc.w  	1027		;Vertical Interrupt, nur ungerade Werte !


